import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
import React, { useState } from 'react';
import PropTypes from 'prop-types';
import { useClassNames } from '../utils';
export var ContainerContext = /*#__PURE__*/React.createContext({});
var defaultProps = {
  as: 'section',
  classPrefix: 'container'
};
var Container = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var Component = props.as,
      classPrefix = props.classPrefix,
      className = props.className,
      children = props.children,
      rest = _objectWithoutPropertiesLoose(props, ["as", "classPrefix", "className", "children"]);

  var _useState = useState(false),
      hasSidebar = _useState[0],
      setHasSidebar = _useState[1];

  var _useClassNames = useClassNames(classPrefix),
      withClassPrefix = _useClassNames.withClassPrefix,
      merge = _useClassNames.merge;

  var classes = merge(className, withClassPrefix({
    'has-sidebar': hasSidebar
  }));
  return /*#__PURE__*/React.createElement(ContainerContext.Provider, {
    value: {
      setHasSidebar: setHasSidebar
    }
  }, /*#__PURE__*/React.createElement(Component, _extends({}, rest, {
    ref: ref,
    className: classes
  }), children));
});
Container.displayName = 'Container';
Container.defaultProps = defaultProps;
Container.propTypes = {
  className: PropTypes.string,
  children: PropTypes.node,
  classPrefix: PropTypes.string
};
export default Container;